/*
 * 20170728-14-6048.c
 *
 *	方程式 x^3 = 7 の根を二分法を用いて求める
 */

#include <stdio.h>
#include <math.h>
#include "s_print.h"
#include "s_input.h"

/*
 *	二分法による、方程式「x^3 = 7」の根の計算
 */

#define	EPSILON	(0.0001)	/* 最小誤差小数点 4 位にする */

double x3_x_sub ( double min, double max, double mid ) {

	   if ( max - min < EPSILON ) {

				/*
				 * 十分に精度が得られたので、その結果を値とする
				 */


	/*
	**	 この部分を完成させなさい
	*/


	   } else if ( mid*mid*mid - 7 < 0.0 ) {

				/*
				 * 答は mid と max の間にある
				 */


	/*
	**	 この部分を完成させなさい
	*/


	   } else {

				/*
				 * 答は min と mid の間にある
				 */

			return x3_x_sub ( min, mid, (min+mid)/2.0 );
	   }

}

double x3_x ( void ) {

		/*
		 *	x^3 = 7 の解は 0 と 7 の間にある
		 */

	   return x3_x_sub ( 0.0, 7, 7/2.0 );

}

/*
 *
 */

int main ( int argc, char *argv[] ) {

	s_print_string ( "x^3 = 7 の方程式の解は " );
	s_print_double ( x3_x() );
	s_print_string ( "です。\n" );

	s_print_string ( "確かに " );
	s_print_double ( x3_x() );
	s_print_string ( "^3 = " );
	s_print_double ( x3_x() * x3_x() * x3_x() );
	s_print_string ( " です。\n" );

	return 0;
}

/*
 *
 */

